﻿using System;
using System.Data;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Configuration;

namespace UsandoTreeView
{
    public partial class frmProdutos : Form
    {

        /// <summary>
        /// Define as variáveis usadas no formulário 
        /// A string de conexão obtida do arquivo App.Config
        /// O DataReader usado
        /// A conexão usada
        /// </summary>
        static string strConexaoSQL = ConfigurationManager.ConnectionStrings["conexaoSQL_Northwind"].ToString();
        SqlDataReader dr;
        SqlConnection conn = new SqlConnection(strConexaoSQL);

        public frmProdutos()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Chama a rotina para vincular os dados no 
        /// TreeView e DataGridView
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void frmProdutos_Load(object sender, EventArgs e)
        {
            carregaDadosTreeView();
        }

        /// <summary>
        /// Carrega dados no TreeView
        /// </summary>
        private void carregaDadosTreeView()
        {
            tvwProdutos.Nodes.Clear();
            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand("SELECT ProductName FROM Products", conn);
                dr = cmd.ExecuteReader();
                while (dr.Read())
                {
                    tvwProdutos.Nodes.Add(dr.GetValue(0).ToString());
                }
                dr.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                conn.Close();
            }
        }

        /// <summary>
        /// Carrega os dados a partir da tabela Alunos pelo nome
        /// </summary>
        /// <param name="nome"></param>
        private void carregaDadosTextBox(string nome)
        {
            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand("SELECT * FROM Products where ProductName = '" + nome + "'", conn);
                dr = cmd.ExecuteReader();
                while (dr.Read())
                {
                    txtCodigo.Text = dr["ProductID"].ToString();
                    txtNome.Text = dr["ProductName"].ToString();
                    txtPreço.Text = dr["UnitPrice"].ToString();
                    txtEstoque.Text = dr["UnitsInStock"].ToString();
                }
                dr.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            finally
            {
                conn.Close();
            }
        }
       
   
        /// <summary>
        /// Após selecionar um item no TreeView
        /// chama a rotina para preencher os textbox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void tvwProdutos_AfterSelect(object sender, TreeViewEventArgs e)
        {
            string strNome = this.tvwProdutos.SelectedNode.Text.ToString();
            carregaDadosTextBox(strNome);
        }
    }
}
